# GSAP (GreenSock Animation Platform)

#### Professional-Grade HTML5 Animation

GSAP is a suite of tools for scripted, high-performance HTML5 animations that work in all major browsers. No other library delivers such advanced sequencing, API efficiency, and tight control. Stop wrestling with cumbersome CSS animations, stuttery jQuery.animate() calls, or a system that limits your creativity. Use animation to tell a story in a rich way rather than settling for a few fades and slides.

This is the public repository for GreenSock's JavaScript tools like <a href="http://www.greensock.com/gsap-js/" target="_blank">GSAP</a> and <a href="http://www.greensock.com/draggable/" target="_blank">Draggable</a>. "GSAP" describes all of the animation-related tools which include TweenLite, TweenMax, TimelineLite, TimelineMax, various plugins (like CSSPlugin for animating CSS properties of DOM elements), extra easing functions, etc. 

### Resources

* <a href="http://www.greensock.com/gsap-js/">GSAP home page</a>
* <a href="http://www.greensock.com/get-started-js/">Getting started guide</a>
* <a href="http://www.greensock.com/why-gsap/">Why GSAP?</a> (a practical guide for developers)
* <a href="http://www.greensock.com/jump-start-js/">Jump Start</a> (visually demonstrates the basic concepts)
* <a href="http://api.greensock.com/js/">Full documentation</a>
* <a href="http://www.greensock.com/draggable/">Draggable demo</a>
* <a href="http://www.greensock.com/jquery-gsap-plugin/">jQuery plugin</a>

Copyright (c) 2014, GreenSock. All rights reserved. This work is subject to the <a href="http://www.greensock.com/terms_of_use.html">terms of use</a> or for Club GreenSock members, the software agreement that was issued with the membership.